random-commands/cronjob-warn-smtp-queue

48 lines
1.4 KiB
Bash
Executable file

#!/bin/bash
# Default configuration.
EMAIL_TO=('sysadmin@slackware.uk')
EMAIL_FROM="\"Server: ${HOSTNAME%%.*}\" <noreply@slackware.uk>"
# Allow /etc/default/warn-smtp-queue to override default configuration.
[[ -e /etc/default/warn-smtp-queue ]] && {
# shellcheck disable=SC1091
source /etc/default/warn-smtp-queue || {
printf "%s: %s\\n" "${0##*/}" "failed reading /etc/default/warn-smtp-queue" >&2
exit 1
}
}
# Don't do anything unless 'mailq' is installed.
hash mailq 2>/dev/null && {
# Prevent a race with other cron jobs that produce emails.
sleep $(( 10 + (RANDOM % 30) ))
# Get the queue
TMP_OUTPUT="$(mailq)"
[[ -z "$TMP_OUTPUT" ]] && exit 0
# Send the message.
if [[ -n "${EMAIL_TO[*]}" ]]; then
if hash mailx >/dev/null 2>&1; then
mailx -S "from=$EMAIL_FROM" -s "Mail queue" "${EMAIL_TO[@]}" <<<"$TMP_OUTPUT" 2>/dev/null || {
printf "%s: %s\\n" "${0##*/}" "mailx command failed" >&2
exit 1
}
elif hash mail >/dev/null 2>&1; then
mail -r "$EMAIL_FROM" -s "Mail queue" "${EMAIL_TO[@]}" <<<"$TMP_OUTPUT" 2>/dev/null || {
printf "%s: %s\\n" "${0##*/}" "mail command failed" >&2
exit 1
}
else
printf "%s: %s\\n" "${0##*/}" "no mailer command found" >&2
exit 1
fi
else
printf "%s: %s\\n" "${0##*/}" "no recipient configured for mail delivery" >&2
exit 1
fi
}
exit 0